#define  FNODATDEF 33
c     reduce the file size; exmine the number of particles (N)
c     in each (r,fai) bin and if it exceeds a limit,
c     each partilce is discarded with the probabilty of
c     1-limit/N.
c       input file: combined  .nrfai data.  give it by environmental
c                   varialbe NRFAIFILE
c                   each  .dat file (binary file)    main output from sim. 
c                   give it by env. vari.  DATFILE
c                   env. vari.  HEADER  for the first set  give it "yes"
c                   else 'no'.  
c       output file:  size reduced file corresponding to .dat; this is put  stdout (ascii)
c                   so this must be concatinated to get combied .dat file.
c                   nrfaifile for each .dat; -r is attached as .nrfai-r.
c                    you must combine .nrfai-r files;
c                   rm old each .nrfai file. and rename .nrfai-r to .nrfai
c                   and use assemNrfai.csh in Assemble.
c  ********"all" data in   .nrfai-r  is really the "all" so this one should not be
c           added any more in  assemNrfai
#include "../FleshHist/asinfo.f"
#include "../FleshHist/asdensity.f"
#include "../FleshHist/crecprob.f"
      implicit none
#include "../FleshHist/Zprivate0.h"
#include "../FleshHist/Zprivate1.h"
#include "../FleshHist/Zprivate3.h"

      integer  ldep,  
     *        charge, ridx, faiidx, codex

      real*8 u
      integer ndepth
      integer EventNo
      integer*2 code
      real*8   Et,  wx, wy, wz
      real    E0
      parameter (ndepth= nsites)
      real nrfaiRec0(nrbin, nfai, 4, ndepth)
      real rnrfaiRec(nrbin, nfai, 4, ndepth)
      real pnrfaiRec(nrbin, nfai, 4, ndepth)
      real nrfaiAll0(nrbin, nfai, 4, ndepth)
      real dErfai(nrbin, nfai,  ndepth)
      real recprob(nrbin, 4, ndepth)

      integer EvNo0

      real limit
      real rat, all, rec, prob
      integer klena
      real intdep(ndepth)
      integer nrbina, nfaia, ansites0
      integer leng, i, j, k, l, leng2, lengh
      integer i0, j0, k0, l0
      integer NN
      integer icon0, iconx, icont
      character*128 input0
      character*100 nrfaifile, nrfaifile2, datfile, datfile2
      character*3 id
      character*5 id5
c      character*5 header
      integer fnonrfai, fnonrfai2,  fnodat2
      real  cosz, age, sum, Nx, depth
      real nptcls(nrbin, 4,  ndepth)
      integer indivdep(ndepth),  packeddepidx(ndepth), depidx
c      real rnptcls(nrbin, 4,  ndepth)
      integer  icon, kgetenv2, nrec


      fnonrfai=11
      fnonrfai2=21
c      fnodat = 6
c      fnodat2 = 8
      nrfaifile=" "
      leng = kgetenv2("NRFAIFILE", nrfaifile)
      if(leng .le. 0) then
         write(0,*) "Env. NRFAIFILE not given"
         stop 11111
      endif
      call copenfw2(fnonrfai, nrfaifile, 1, icon)
      if(icon .ne. 1) then
         write(0,*) ' error cannot open', nrfaifile
         stop 0000
      endif

      leng2 = kgetenv2("DATFILE", datfile)
      if(leng2 .le. 0) then
         write(0,*) "Env. DATFILE not given"
         stop 11112
      endif
      call copenfw2(fnodat, datfile, 2, icon)
      if(icon .ne. 1) then
         write(0,*) ' input main data not exist'
         write(0,*) ' file=',datfile
         stop 1113
      endif

      datfile2 =" "
      datfile2 = datfile(1:leng2)//"-r"
      nrfaifile2 =" "
      nrfaifile2 = datfile(1:leng2-3)//"nrfai-r"
      call copenfw2(fnonrfai2, nrfaifile2, 1, icon)
      if(icon .ne. 0) then
         write(0,*) ' error ', nrfaifile2, ' cannot be created'
         stop 1235
      endif
c      lengh= kgetenv2("HEADER", header)

      do k = 1,  ndepth
         packeddepidx(k)=0
         do j = 1, 4
            do l = 1,nfai
               do i = 1, nrbin
                  rnrfaiRec(i, l, j, k)=0
               enddo
            enddo
         enddo
      enddo
c
      do while(.true.)
         input0 = ' '
         read(fnonrfai, '(a)',  end=1000 ) input0
         if(input0 .ne. " ") then
            read(input0(1:klena(input0)), *) 
     *           EvNo0, E0,NN, cosz, limit,  nrbina, nfaia, ansites0

            write(0,*) input0

            if(nrbina .ne. nrbin .or. nfaia .ne. nfai) then
               write(0,*)' nrbina=',nrbina, 'or  nfaia=',nfaia,
     *              ' differ from the def. in this prog'
               stop 5555
            endif
            if(ansites0 .gt. ndepth) then
               write(0,*) ' too many depths'
               stop 6666
            endif
c           ********
            do i = 1, ansites0
               do j = 1, 4
                  do k = 1, nfai
                     read(fnonrfai, '(a, f7.1,  4i4)' )
     *               id, intdep(i), l0, i0, j0, k0
                     indivdep(i)=l0
                     packeddepidx(l0)=i  !  original dep index to packed indx
                     
c
c        when the above is written
c        l = indivdep(i)
c        write(fnonrfai, '("rec",f7.1, 4i4)' )
c     *     ASDepthList(l)*0.1, l, i, j, k
                                   

                     if(i0 .ne. i .or. j .ne. j0 .or. k .ne. k0) then
                        write(0,*) ' intdep, i0,j0,k0=',
     *                      intdep(i), i0, j0, k0, ' strange'
                        stop 8888
                     endif
                     if( id .ne. "rec") then
                        write(0,*) 'id=',id, ' strange'
                        stop 5678
                     endif
c
                     read(fnonrfai, *)
     *                    ( nrfaiRec0(l,k,j,i), l=1,nrbin )
                  enddo
               enddo
            enddo
c    ************
            do i = 1, ansites0
               do j = 1, 4
                  do k = 1, nfai
                     read(fnonrfai, '(a,f7.1, 4i4)' )
     *                id,  intdep(i), l0, i0, j0, k0
                     indivdep(i)=l0
                     if(i0 .ne. i .or. j .ne. j0 .or. k .ne. k0) then
                        write(0,*) ' intdep, i0,j0,k0=',
     *                      intdep(i), i0, j0, k0, ' strange'
                        stop 9876
                     endif
                     if( id .ne. "all") then
                        write(0,*) 'id=',id,' strange'
                        stop 9999
                     endif
                     read(fnonrfai, *)
     *                    ( nrfaiAll0(l,k,j,i), l=1,nrbin )
                  enddo
               enddo
            enddo
c              dErfai
            do i = 1, ansites0
               do k = 1, nfai
                  read(fnonrfai, '(a,f7.1, 3i4)' )
     *                 id5,  intdep(i), l0, i0,  k0
                  indivdep(i)=l0
                  if(i0 .ne. i .or.  k .ne. k0) then
                     write(0,*) ' intdep, i0,k0=',
     *                      intdep(i), i0, k0, ' strange'
                     stop 98765
                  endif
                  if( id5 .ne. "dE/dx") then
                     write(0,*) 'id=',id5,' strange'
                     stop 9999
                  endif
                  read(fnonrfai, *)
     *                 ( dErfai(l,k,i), l=1,nrbin )
               enddo
            enddo
         else
c      
            write(0,*) ' all nrfai data has been read'
            limit = 7500.
            write(0, '(i2, 1pE11.3,i3, 0pf7.1, 1pE11.3, 3i4)')
     *       EvNo0, E0,NN, cosz, limit,  nrbina, nfaia, ansites0
         endif
      enddo
 1000 continue
      input0= ' '
c************* reset limit
c      limit=min(4000.0, limit)
      limit=7500
      write(0,*) ' limit=',limit, ' is being used'
c************ 
      do i = 1,  ansites0
         do j = 1, 4
            do k = 1,nfai
               do l = 1, nrbin
                  if(nrfaiRec0(l, k, j, i) .gt. limit) then
c                       accept with this prob.
                     pnrfaiRec(l, k, j, i)=
     *                    limit/nrfaiRec0(l, k, j, i) 
                  else
                     pnrfaiRec(l, k, j, i)=1.0
                  endif
               enddo
c///////
               write(0, '(f7.1,  4i4,a)' )
     *              intdep(i), indivdep(i), i, j, k, ' prob' 
               write(0, '(1p10E11.3)')
     *               (pnrfaiRec(l,k,j,i), l=1, nrbin)
cc/////
            enddo
         enddo
      enddo
c  -------------
c            main input data; header Obsolete
c      read(fnodat)  EventNo, code,   Et,  wx, wy, wz
c      if( header(1:lengh) .eq. "yes") then
c         write(*,'("i ",  i3,  i4, g13.4,3f11.7)')
c     *        EventNo, code,   Et,  wx, wy, wz
c      endif

      nrec= 0
      do while(.true.)
         read(fnodat,end=100) bufc, (buf(i), i=1, bufc)
c/////////////
c         write(0,*) ' bufc=',bufc
c///////////
         do i = 1, bufc
            nrec= nrec+1
            ldep = buf(i).ldep
            depidx = packeddepidx(ldep)
            faiidx=  buf(i).faiidx
            ridx = buf(i).ridx
            codex=min(buf(i).code, 4)
            call rndc(u)
            if(u .lt.
     *           pnrfaiRec(ridx, faiidx, codex, depidx) )  then
               rnrfaiRec(ridx, faiidx, codex, depidx)=
     *              rnrfaiRec(ridx, faiidx, codex, depidx) + 1

               if(wz .lt. 0.999) then
                  write(*,
     *             '(6i3, 1pE11.3, 0p,f6.1,1p2E11.3,0p, 2f8.4,f10.6)')
     *              buf(i).ldep,  buf(i).code,  buf(i).subcode,
     *              buf(i).charge, buf(i).ridx, buf(i).faiidx,
     *              buf(i).rinmu, buf(i).fai, buf(i).Ek,
     *              buf(i).t, buf(i).wx, buf(i).wy, buf(i).wz
               else
                  write(*,'(6i3,1pE11.3, 0p, f6.1, 1p2E11.3, a)')
     *                 buf(i).ldep,  buf(i).code,  buf(i).subcode,
     *                 buf(i).charge, buf(i).ridx, buf(i).faiidx,
     *                 buf(i).rinmu, buf(i).fai, buf(i).Ek,
     *                 buf(i).t, ' 0 0 1'
               endif
            endif
         enddo
      enddo
 100  continue

      write( fnonrfai2,
     *     '(i2,1pE11.3, 0p,i3, f8.4, 1pE11.3,3i4)' )
     *     EvNo0, E0, NN, cosz, limit, nrbin, nfai, ansites0

      do i = 1, ansites0
         do j = 1, 4
            do k = 1, nfai
               l = indivdep(i)
               write(fnonrfai2, '("rec",f7.1, 4i4)' )
     *          intdep(i), l, i, j, k
               write(fnonrfai2, '(1p10E11.3)')
     *             ( rnrfaiRec(l,k,j,i), l=1,nrbin )
            enddo
         enddo
      enddo
      do i = 1, ansites0
         do j = 1, 4
            do k = 1, nfai
               l = indivdep(i)
               write(fnonrfai2, '("all",f7.1, 4i4)' )
     *          intdep(i), l, i, j, k
               write(fnonrfai2, '(1p10E11.3)')
     *             ( nrfaiAll0(l,k,j,i), l=1,nrbin )
            enddo
         enddo
      enddo
c       dErfai
      do i = 1, ansites0
         do k = 1, nfai
            l = indivdep(i)
            write(fnonrfai2, '("dE/dx",f7.1, 3i4)' )
     *           intdep(i), l, i, k
            write(fnonrfai2, '(1p10E11.3)')
     *           ( dErfai(l,k,i), l=1,nrbin )
         enddo
      enddo
      
      write(0,*) 'end of run'
      write(fnonrfai2, *) 
      stop
 500  continue
      write(0,*) ' input error at record =', nrec
      end
